/*
 * MemAccessMonitor.h
 *
 *  Created on: 14/06/2009
 *      Author: Gil Kulish
 */
#include "ThreadMemInfo.h"
#include <iostream>
#include <string>
#include <list>
#include <map>
#include "globals.h"

#define CACHE_SIZE 1024
#define MEM_ROW_SIZE 8
//mem mask is used for calculations of memory row address from a memory address
#define MEM_MASK (~(MEM_ROW_SIZE-1))
#define CACHE_SIZE_IN_LINES (CACHE_SIZE / MEM_ROW_SIZE)
#define MEM_MASK_SIZE_IN_BITS 3

using namespace std;

#ifndef MEMACCESSMONITOR_H_
#define MEMACCESSMONITOR_H_

class MemAccessMonitor {
	// a map of

	map<char *,ThreadMemInfo*> memoryReads[CACHE_SIZE_IN_LINES];
	map<char *,ThreadMemInfo*> memoryWrites[CACHE_SIZE_IN_LINES];

public:
	void printToFile(list<char*> *processors);

	list<char*> *maximalAccess(int groupSize,list<char*> &sameTimeThreads,map<char*, ThreadMemInfo *> &writingThreads,map<char*, char*> &alreadyScheduled);

	PTR_TYPE getMemLineAddressByMemAddress(PTR_TYPE mem);
	static MemAccessMonitor *getInstance();
	static MemAccessMonitor *instance;
	virtual ~MemAccessMonitor();
	void markWrite(char* argName,PTR_TYPE address,char *threadLogicalName);
	void markRead(char* argName,PTR_TYPE address,char *threadLogicalName);
	void printCacheAccess();
	void printScheduleAdvice();
protected:
	void markAccess(map<char *,ThreadMemInfo*> *memoryAccess,char* argName, PTR_TYPE address,char *threadLogicalName);
	MemAccessMonitor();

};

#endif /* MEMACCESSMONITOR_H_ */
