#include "time.h"
#define STOP_ITER 100000000
#define CACHE_LINE_SIZE 8
#define PROC_NUM 8


int main(){
  long globalData[PROC_NUM][1],gj[PROC_NUM][1],localData[PROC_NUM][CACHE_LINE_SIZE],lj[PROC_NUM][CACHE_LINE_SIZE];
  long i=0,processors=0;
  long time;
  clock_t t1,t2;
  printf("\n\nContention Penalty\n%d processors %d iterations %d byte spacing between the local variables of each thread\n",
      PROC_NUM, STOP_ITER, CACHE_LINE_SIZE * sizeof(long));

  printf("measuring local access contention\n");

  for (processors=1; processors<PROC_NUM+1; processors++){
    t1=clock();
    parfor (i=0; i<PROC_NUM+1; i++){
      if (i<processors){
	for (lj[i][0]=0; lj[i][0]<STOP_ITER; lj[i][0]++){
	  localData[i][0]=lj[i][0]%(1+localData[i][0]);
	}
     }
    }
    t2=clock();
    time=t2-t1;
    printf("time for local access with %d threads: %ld, time/threads: %ld\n",processors,time,time/processors);
  }

  printf("\nmeasuring global access contention\n");
  
  for (processors=1; processors<PROC_NUM+1; processors++){
    t1=clock();
    parfor (i=0; i<PROC_NUM+1; i++){
      if (i<processors) {
	for (gj[i][0]=0; gj[i][0]<STOP_ITER; gj[i][0]++){
	  globalData[i][0]=gj[i][0]%(1+globalData[i][0]);
	}
      }
    }
    t2=clock();
    time=t2-t1;
    printf("time for global access with %d threads: %ld, time/threads: %ld\n",processors,time,time/processors);
  }
    
  return 0;
}