/*
 * ParJoin.cpp
 *
 *  Created on: 09/04/2009
 *      Author: Gil Kulish
 */

#include <ParJoin.h>
#include <stdio.h>
#include <pth.h>
#include <pth_p.h>
//thre only reason for including thread.h is because of the debug functions
#include <Thread.h>
void pth_join_all();
ParJoin::~ParJoin() {

}

ParJoin::ParJoin(int _openThreads) {
	openThreads = _openThreads;
	pthread_mutex_init(&count_mutex, NULL);
	pthread_cond_init(&count_threshold_cv, NULL);
}

void ParJoin::signalThreadFinished() {
	debug_printf1("signalThreadFinished called\n");
	pthread_mutex_lock(&count_mutex);
	debug_printf3("reducing open threads from %d to %d\n",openThreads,openThreads-1);
	openThreads--;
	debug_printf3("open threads reduced from %d to %d\n",openThreads+1,openThreads);
	if (openThreads == 0) {
		pthread_cond_broadcast(&count_threshold_cv);
	} else if (openThreads < 0) {
		debug_printf1("Oo Oo a big problem in parJoin; call support\n");
	}
	pthread_mutex_unlock(&count_mutex);
	debug_printf3("PJ %x  reduced one threads on lock %x\n",this,&count_mutex);
	debug_printf2("current open threads number: %d\n",openThreads);

}
void ParJoin::signalNewThreadOpened() {
	pthread_mutex_lock(&count_mutex);
	openThreads++;
	pthread_mutex_unlock(&count_mutex);

}
void ParJoin::signalNNewThreadsOpened(int n) {
	pthread_mutex_lock(&count_mutex);
	openThreads += n;
	pthread_mutex_unlock(&count_mutex);

}

void ParJoin::join() {
	debug_printf3("waiting in PJ %x on lock %x\n",this,&count_mutex);
	pthread_mutex_lock(&count_mutex);
	ThreadLocalData *tld = getPthThreadLocal();
	while (openThreads > 0) {
		if (!tld ) {
			// if tld is null then we can sleep
			pthread_cond_wait(&count_threshold_cv, &count_mutex);
		} else {
			// if in pth; we need to yield
			pthread_mutex_unlock(&count_mutex);
			pth_yield(NULL);
			pthread_mutex_lock(&count_mutex);
		}
	}
	pthread_mutex_unlock(&count_mutex);
	debug_printf3("Finished waiting for all user-threads in PJ %x on lock %x\n",this,&count_mutex);
	debug_printf2("open threads number: %d\n",openThreads);
}

