/*
 * ParForJob.h
 *
 *  Created on: 15/04/2009
 *      Author: Gil Kulish
 */

#ifndef PARFORJOB_H_
#define PARFORJOB_H_

#include <Runnable.h>
#include <UserThread.h>
#include "globals.h"
class ParForJob : public Runnable{
public:

	virtual char *getThreadGroupName();

	// this map is used to store the thread's "logical name". the logical name is created
	// from the thread's group name, and a sequence.
	// the logical name, is needed so that the memory profiler and the scheduler modules can identify
	// a thread in a one-to-one manner.
	static map <PTR_TYPE,char*> threadNumToLogicalName;
	//threadGroupName is the name of the parc "general" thread, that this thread forked from.
	#define MAX_DEPTH_AND_INSTANCS 25
	char threadLogicalName[MAX_DEPTH_AND_INSTANCS];

	UserThread *lazyThread;
	int __start;
	int __end;
	ParForJob(int __start, int __end);
	virtual ~ParForJob();
};

#endif /* PARFORJOB_H_ */
