/*
 * ParJoin.h
 *
 *  Created on: 09/04/2009
 *      Author: Gil Kulish
 */
/**
 * this file was created in order to give a solution to the need to wait (join) on lazy (dynamic) threads,
 * like the threads of the parc model, where the main (spawning/forking) thread, wants to wait (using join) for the spawned threads to finish their job,
 * but it is not yet known how many threads, will actually take a part in performing the task, or if they will
 * be kernel threads or user threads or simply serial execution of the code.
 *
 */
#ifndef PARJOIN_H_
#define PARJOIN_H_
#include <pthread.h>
class ParJoin {
public:
	// a variable that holds the number of threads that need to finish running for the "join" not to block;
	int openThreads;
	pthread_mutex_t count_mutex;
	pthread_cond_t count_threshold_cv;

	void join();
	void signalThreadFinished();
	void signalNewThreadOpened();
	void signalNNewThreadsOpened(int n);
	ParJoin(int openThreads);
	virtual ~ParJoin();
};

#endif /* PARJOIN_H_ */
