#ifndef THREAD_H

#define THREAD_H

#include <stdio.h>
#include <time.h>
#include <pthread.h>
#include <Runnable.h>
#include <map>

using namespace std;
class Thread: public Runnable {
private:
	pthread_t thread;

public:


	static void *thread_func(void *d);
	Thread();
	Thread(Runnable *whatToRun);
	Thread(Runnable *whatToRun, ParJoin *_pj);
	virtual void run();
	virtual int start();
	virtual int wait();
	virtual int join();
	Runnable *toRun;
	virtual void setPJ(ParJoin *_pj);

};

#ifndef DEBUG
#define debug_printf1(a1)                     /* NOP */
#define debug_printf2(a1, a2)                 /* NOP */
#define debug_printf3(a1, a2, a3)             /* NOP */
#define debug_printf4(a1, a2, a3, a4)         /* NOP */
#define debug_printf5(a1, a2, a3, a4, a5)     /* NOP */
#define debug_printf6(a1, a2, a3, a4, a5, a6) /* NOP */
#define debug_printf7(a1, a2, a3, a4, a5, a6 , a7) /* NOP */
#else
#define debug_printf1(a1)                     printf(a1)
#define debug_printf2(a1, a2)                 printf(a1,a2)
#define debug_printf3(a1, a2, a3)             printf(a1,a2,a3)
#define debug_printf4(a1, a2, a3, a4)         printf(a1,a2,a3,a4)
#define debug_printf5(a1, a2, a3, a4, a5)     printf(a1,a2,a3,a4,a5)
#define debug_printf6(a1, a2, a3, a4, a5, a6) printf(a1,a2,a3,a4,a5,a6)
#define debug_printf7(a1, a2, a3, a4, a5, a6 , a7) printf(a1,a2,a3,a4,a5,a6,a7)

#endif

#endif
