/*
 * pth_parc_ext.c
 *
 *  Created on: 03/04/2009
 *      Author: Gil Kulish
 */
/* Gil Kulish@new */
#include <pth_p.h>
#include <pthread.h>

intern pthread_key_t key;
intern pthread_once_t key_once = PTHREAD_ONCE_INIT;
intern void make_key()
{
	(void) pthread_key_create(&key, NULL);
}

#if cpp
struct ThreadLocalData
{
	pth_pqueue_t* localPth_RQ;
	pth_pqueue_t* localPth_WQ;
	pth_pqueue_t* localPth_SQ;
	pth_pqueue_t* localPth_DQ;
	pth_pqueue_t* localPth_NQ;
	pth_t*	localPth_sched;
	pth_t*	localPth_current;
	pth_t*	localPth_main;
};

typedef struct ThreadLocalData ThreadLocalData;

#endif /* cpp */
/*
 * return true if already initialized; else (if it's the first call) returns false*/
intern int pth_initThreadLocals()
{
	ThreadLocalData *ptr;
	if ((ptr = pthread_getspecific(key)) == NULL) {
        pth_debug2("initializing thread local data (for pth) Pthread id is : %x\n",pthread_self());
		ptr=(ThreadLocalData*)malloc(sizeof(ThreadLocalData));
		ptr->localPth_DQ=(pth_pqueue_t*)malloc(sizeof(pth_pqueue_t));
		ptr->localPth_WQ=(pth_pqueue_t*)malloc(sizeof(pth_pqueue_t));
		ptr->localPth_SQ=(pth_pqueue_t*)malloc(sizeof(pth_pqueue_t));
		ptr->localPth_NQ=(pth_pqueue_t*)malloc(sizeof(pth_pqueue_t));
		ptr->localPth_RQ=(pth_pqueue_t*)malloc(sizeof(pth_pqueue_t));
		ptr->localPth_sched=(pth_t*)malloc(sizeof(pth_t));
		ptr->localPth_current=(pth_t*)malloc(sizeof(pth_t));
		ptr->localPth_main=(pth_t*)malloc(sizeof(pth_t));
		(void) pthread_setspecific(key, ptr);
		return FALSE;
	}
	return TRUE;

}

intern ThreadLocalData* getPthThreadLocal()
{
	return pthread_getspecific(key);
}
/** return true; if the thread was initialized; false if not*/
intern int pth_isInitialized()
{
	return (pthread_getspecific(key)!=NULL);
}

/** return true; if the thread was initialized; false if not*/
intern int pth_killThreadLocals()
{
	ThreadLocalData *ptr;
	if ((ptr = pthread_getspecific(key)) != NULL) {
		(void) pthread_setspecific(key, NULL);
        pth_debug2("killing thread local data (for pth) \"%s\"", (*ptr->localPth_current)->name);
		free(ptr->localPth_DQ);
		free(ptr->localPth_WQ);
		free(ptr->localPth_SQ);
		free(ptr->localPth_NQ);
		free(ptr->localPth_RQ);
		free(ptr->localPth_sched);
		free(ptr->localPth_current);
		free(ptr->localPth_main);
		free(ptr);
		return TRUE;
	}
	return FALSE;

}
intern pth_pqueue_t* getPth_NQ()
{
	ThreadLocalData* ptr = pthread_getspecific(key);
	return ptr->localPth_NQ;
}

intern pth_pqueue_t* getPth_RQ()
{
	ThreadLocalData* ptr = pthread_getspecific(key);
	return ptr->localPth_RQ;
}
intern pth_pqueue_t* getPth_WQ()
{
	ThreadLocalData* ptr = pthread_getspecific(key);
	return ptr->localPth_WQ;
}
intern pth_pqueue_t* getPth_SQ()
{
	ThreadLocalData* ptr = pthread_getspecific(key);
	return ptr->localPth_SQ;
}
intern pth_pqueue_t* getPth_DQ()
{
	ThreadLocalData* ptr = pthread_getspecific(key);
	return ptr->localPth_DQ;
}

intern pth_t getPth_current()
{
	ThreadLocalData* ptr = pthread_getspecific(key);
	return *ptr->localPth_current;
}

intern pth_t getPth_main()
{
	ThreadLocalData* ptr = pthread_getspecific(key);
	return *ptr->localPth_main;
}

intern pth_t getPth_sched()
{
	ThreadLocalData* ptr = pthread_getspecific(key);
	return *ptr->localPth_sched;
}

intern pth_t setPth_sched(pth_t _pthSched)
{
	ThreadLocalData* ptr = pthread_getspecific(key);
	return *ptr->localPth_sched=_pthSched;
}

intern pth_t setPth_current(pth_t _pthCurrent)
{
	ThreadLocalData* ptr = pthread_getspecific(key);
	return *ptr->localPth_current=_pthCurrent;
}

intern pth_t setPth_main(pth_t _pthMain)
{
	ThreadLocalData* ptr = pthread_getspecific(key);
	return *ptr->localPth_main=_pthMain;
}

/* end of Gil Kulish@new */
